#!/usr/bin/perl -I/usr/sausalito/perl -I/usr/sausalito/handlers/base/power
# $Id: wakemode.pl,v 1.9 2001/10/01 23:45:34 jcheng Exp $
# Copyright 2000, 2001 Sun Microsystems, Inc., All rights reserved.

use CCE;
use Sauce::Util;
use I18n;

my ($return1, $return2);
my $flag = 0;
my $port;
my $kernel_wakeutil = '/usr/sbin/ethtool';
my $eeprom_wakeutil = '/usr/sbin/enet_eeprom';
my $cce = new CCE("Namespace" => "Power");
$cce->connectfd();

my $old = $cce->event_old();
my $object = $cce->event_object();
my $new = $cce->event_new();

# find out what IO port the ethernet controller uses.
open PCI, '</proc/pci';
while (<PCI>) {
    if (/Ethernet/) {
	$flag = 1;
    } elsif ($flag && /I\/O/) {
	/at (\w+)/;
	$port = $1;
	last;
    }
}
close(PCI);

my @eeprom_args = ($eeprom_wakeutil, '-p', $port, '-d', 'natsemi', '-w', 'wol');
my @kernel_args = ($kernel_wakeutil, '-s', 'eth0', 'wol');

if ($new->{wakemode} || $new->{set_modes_now}) {
    if ($object->{wakemode} eq 'none') {
	push @kernel_args, ('d');
	push @eeprom_args, ('d');
    } elsif ($object->{wakemode} eq 'magic') {
	push @kernel_args, ('g');
	push @eeprom_args, ('g');
    }
    
    $return1 = system(@kernel_args);
    $return2 = system(@eeprom_args);

    if (($return1 != 0) || ($return2 != 0)) {
	$cce->warn("[[base-power.errSettingWakeMode]]");
	$cce->bye('FAIL');
	exit 1;
    }
}

$cce->bye('SUCCESS');
exit 0;

